'-------------------------------- Data02 ---------------------------------'
'									  '
' This program explores proper matching of loop counters to code inside	  '
' the loop.  Repetitive computation of sin(x) is used as working code	  '
'									  '
'-------------------------------------------------------------------------'

'global declarations
'longs
Dim itcounter 	As Long		'iteration counter for routine
Dim degCounter	As Long		'sin(x) counter as Long		


'singles
Dim timestart 	As Single	'ticks at start of loop
Dim timestop 	As Single	'ticks at loop exit

'doubles
Dim CDeg2Rad	As Double	'convert degrees to radians
Dim ccDeg2Rad 	As Double	'0.01 degrees in radians
Dim c2Pi	As Double	'2 * Pi
Dim cDegStep	As Double	'Degree step size, the 'precision' 
Dim cRadStep	As Double	'Converts the radian LONG to Double in Meth4
Dim dummy 	As Double	'dummy variable to take sin(angle)
Dim x		As double	'actual sin argument or double counter

'clear the screen
CLS

'initialize 'constants'
CDeg2Rad = 0.017453292
ccDeg2Rad = 0.00017453292
c2Pi = 6.283185307
cDegStep = 0.01
cRadStep = 0.0000001


'-------------------------------- Double Counter in Degrees -----------------

'display message
Print "Starting sin(x) with Double Loop Counter in Degrees ..."
Print


'start the timer
timestart = TImer


For itcounter = 1 to 1000

	For x = 0 to 360 Step cDegStep

		'sin() gets double, no conversion necessary
            	dummy = Sin(x * cDeg2Rad)

	Next x
        
Next itcounter

'stop the timer
timestop = Timer 

'display the result
Print "sin(x) with double counter in degrees in "; timestop - timestart; " seconds"
Print

'------------------------ End Double Counter in Degrees --------------------

'--------------------------- Long Counter in Degrees -----------------------

'display message
Print "Starting sin(x) with Long Loop Counter in Degrees ..."
Print

'start the timer
timestart = Timer


For itcounter = 1 to 1000

        For degCounter = 0 to 36000 Step 1

		'sin() gets double, must convert degcounter
            	dummy = Sin(CDbl(degCounter) * ccDeg2Rad)

	Next degCounter
 
Next itcounter

'stop the timer
timestop = Timer

'display the result
Print "sin(x) with long counter in degrees in "; timestop - timestart; " seconds"
Print
'------------------------- End Loop Counter in Degrees ---------------------

'--------------------------- Double Counter in Radians ---------------------

'display message
Print "Starting sin(x) with Double Loop Counter in Radians ..."
Print

'start the timer
timestart = Timer


For itcounter = 1 to 1000

        'no degree to radian conversion needed, so float math
        'eliminated from inside the loop!
    
        'counter and step are double
        For x = 0 To c2Pi Step ccDeg2Rad
    
            'sin() gets double
            dummy = Sin(x)
        
        Next x
    
 
Next itcounter

'stop the timer
timestop = Timer

'display the result
Print "sin(x) with double counter in radians in "; timestop - timestart; " seconds"
Print
'------------------------- End Double Counter in Radians -------------------

'--------------------------- Long Counter in Radian ------------------------

'display message
Print "Starting sin(x) with Long Loop Counter in Radians ..."
Print

'start the timer
timestart = Timer


For itcounter = 1 to 1000

        'counter and step are longs
        For degCounter = 0 To 62831853 Step 1745
    
            'sin() gets double, type conversion is needed
            dummy = Sin(CDbl(degCounter) * cRadStep)
        
        Next degCounter
   
Next itcounter

'stop the timer
timestop = Timer

'display the result
Print "sin(x) with long counter in radians in "; timestop - timestart; " seconds"
Print
'--------------------- End Long Loop Counter in Radians ---------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END