'-------------------------------- Data03 ---------------------------------'
'                                                                         '
' This program compares the use of immediate to variable (memory)         '
' references in loop structures.                                          '
'                                                                         '
'-------------------------------------------------------------------------'

'global declarations
'longs
DIM itcoutner           AS INTEGER         'iteration counter
DIM Counter             AS INTEGER         'loop counter variable
DIM StartCounter        AS INTEGER         'variable loop starting value
DIM StopCounter         AS INTEGER         'variable loop stop value
DIM StepSize            AS INTEGER         'variable loop step size

'singles
DIM timestart   AS SINGLE       'ticks at start of loop
DIM timestop    AS SINGLE       'ticks at loop exit


'clear the screen
CLS

'initialize the loop variables
StartCounter = 1
StopCounter = 20
StepSize = 1


'---------------------------- Variable Loop Parameters -----------------

'display message
PRINT "Starting routine with variable loop parameters ..."
PRINT

'start the timer
timestart = TIMER


FOR itcounter = 1 TO 10000000

	'do a loop with memory references for loop bounds
	FOR Counter = StartCounter TO StopCounter STEP StepSize
	
	NEXT Counter
 
NEXT itcounter

'stop the timer
timestop = TIMER

'display the result
PRINT "Looped with variable loop parameters in "; timestop - timestart; " seconds"
PRINT

'------------------------------- End Variable Loop -------------------------

'---------------------------- Immediate Loop Parameters --------------------

'display message
PRINT "Starting routine with fixed loop parameters ..."
PRINT

'start the timer
timestart = TIMER


FOR itcounter = 1 TO 10000000

	'do a loop with immediate data for loop bounds
	FOR Counter = 1 TO 20 STEP 1
	
	NEXT Counter
 
NEXT itcounter

'stop the timer
timestop = TIMER

'display the result
PRINT "Looped with fixed loop parameters in "; timestop - timestart; " seconds"
PRINT

'------------------------------- End Immediate Loop ------------------------


' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

