DECLARE FUNCTION LJEnergy! (R AS DOUBLE)
'-------------------------------- Function01 -----------------------------'
'                                                                         '
' This program compares the use of inline functions to function calling.  '
' An empty function is used in this demo, but 'simulates' calling a       '
' Lennard-Jones pair energy function.                                     '
'                                                                         '
'-------------------------------------------------------------------------'

' global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM NumIts      AS LONG         'number of iterations

'singles
DIM starttimer  AS SINGLE       'ticks at start of loop
DIM stoptimer   AS SINGLE       'ticks at loop exit

'doubles
DIM R           AS DOUBLE       'value to pass in function call
DIM E           AS DOUBLE       'return value for function call/computation

'clear the screen
CLS

'initialize the iteration counter
NumIts = 10000000

'set R to zero just for demo
R = 0!


'-------------------------------- Called Function ------------------

'display message
PRINT "Calling a Function ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = LJEnergy(R)

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Called function "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'-------------------------------- End Called Function ----------------------

'-------------------------------- Inline Function --------------------------

'display message
PRINT "Computing with inline code ..."
PRINT

'start the timer
starttimer = TIMER

	DIM Rinline     AS DOUBLE
	DIM r6          AS DOUBLE
	DIM r12         AS DOUBLE
	DIM Einline     AS DOUBLE

FOR counter = 1 TO NumIts

	'do no work except assign value to E
	Einline = 0

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Inline Code Executed "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

' ------------------------------- End Inline Function ----------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

FUNCTION LJEnergy (R AS DOUBLE)

	'local declarations
	'doubles
	DIM r6   AS DOUBLE
	DIM r12  AS DOUBLE

	'return a value
	LJEnergy = 0


END FUNCTION

