DECLARE FUNCTION EnergyVal! (dx AS DOUBLE, dy AS DOUBLE, dz AS DOUBLE)
DECLARE FUNCTION EnergyGlb! ()
'-------------------------------- Function05 -----------------------------'
'                                                                         '
'       This program compares passing the data to the use of              '
'       global data (in this demo, unlike the VB version, the return      '
'       value goes into a global).  No work is done in the functions.     '                                             '                                                                         '
'                                                                         '
'       Also, the number of iterations was reduced to 10,000,000 compared '
'       to the 100,000,000 used in the Windows version                    '
'                                                                         '
'-------------------------------------------------------------------------'

' global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM NumIts      AS LONG         'number of iterations

'singles
DIM starttimer  AS SINGLE       'ticks at start of loop
DIM stoptimer   AS SINGLE       'ticks at loop exit

'doubles
DIM E           AS DOUBLE       'return value for function calls
DIM gdx         AS DOUBLE       'global for dx
DIM gdy         AS DOUBLE       'global for dy
DIM gdz         AS DOUBLE       'global for dz

'-------------------------------- Initializations ------------------------

'clear the screen
CLS

'initialize the iteration counter
NumIts = 10000000

'initialize the gobal data
gdx = 1.567
gdy = 2.066
gdy = 1.439

'-------------------------------- Pass Data Elements ----------------------

'display message
PRINT "Use Function Call with passed values ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = EnergyVal(1.567, 2.066, 1.439)

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Called function passing values"; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT
'--------------------------- End Pass Data Elements ------------------------

'------------------------------ Use Global Data ----------------------------

'display message
PRINT "Using Global Data ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = EnergyGlb

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Called function using that would use global data "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'-------------------------- End Use Global Data ----------------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

FUNCTION EnergyGlb

	'return value into global
	E = 10.456

END FUNCTION

FUNCTION EnergyVal (dx AS DOUBLE, dy AS DOUBLE, dz AS DOUBLE)

	'return a value
	EnergyVal = 10.456


END FUNCTION

