VERSION 5.00
Begin VB.Form frmData01 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Variant vs. Explicit Declarations"
   ClientHeight    =   4080
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "frmData01.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4080
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdExplMismatch 
      Caption         =   "Explicit Type Declarations - With Mismatches"
      Height          =   855
      Left            =   3120
      TabIndex        =   3
      Top             =   1080
      Width           =   1455
   End
   Begin VB.CommandButton cmdClearText 
      Caption         =   "Clear Text"
      Height          =   855
      Left            =   3120
      TabIndex        =   2
      Top             =   3000
      Width           =   1455
   End
   Begin VB.CommandButton cmdExplTypes 
      Caption         =   "Explicit Type Declarations - No Mismatches"
      Height          =   855
      Left            =   3120
      TabIndex        =   1
      Top             =   2040
      Width           =   1455
   End
   Begin VB.CommandButton cmdVntTypes 
      Caption         =   "Implicit Variant Declarations"
      Height          =   855
      Left            =   3120
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "frmData01"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program compares execution times for repetitive floating point
'computation using variant declaration vs. explicit type
'declaration.  Using explicit declarations avoids unneeded
'type conversions.

'Module Globals
'constants
Const cNumIts As Long = 10000000

'Singles
Dim starttime As Single     'time when loop is entered
Dim stoptime As Single      'time when loop exits

'clears text from display area
Private Sub cmdClearText_Click()

    Cls

End Sub

'performs repetitive x^y calculations with 2 type mismatches
'per iteration (uses singles rather than doubles)
Private Sub cmdExplMismatch_Click()

    'local declarations
    'Longs
    Dim counter As Long       'iteration counters
    Dim x As Long             'base
    Dim y As Long             'exponent
    Dim result As Long        'result
    
    'assign base
    x = 2
    
    'assign exponent
    y = 4
    
    'start the timer
    starttime = Timer
    
    For counter = 1 To cNumIts
    
        result = CLng(CDbl(x) ^ CDbl(y))
    
    Next counter

    'stop the timer
    stoptime = Timer
    
    'display the result
    Print
    Print "Using Explicit Declaration with"
    Print "three type mismatches per iteration,"
    Print "Computed x^y "; cNumIts; " times in"
    Print stoptime - starttime; " seconds."
    Print "Result = "; result
    Print



End Sub

'Procedure that uses correct explicit type declarations.
Private Sub cmdExplTypes_Click()

    'local declarations
    'Longs
    Dim counter As Long       'iteration counter
    
    'Doubles
    Dim x As Double         ' base
    Dim y As Double         ' exponent
    Dim result As Double    'result
    
    'assign base
    x = 2
    
    'asign exponent
    y = 4
    
    'start the timer
    starttime = Timer
    
    For counter = 1 To cNumIts
    
        'compute the result
        result = x ^ y
    
    Next counter

    'stop the timer
    stoptime = Timer
    
    'display the result
    Print
    Print "Using Explicit Declaration with"
    Print "No Type Mismatches"
    Print "Computed x^y "; cNumIts; " times in"
    Print stoptime - starttime; " seconds."
    Print "Result = "; result
    Print

End Sub


'All variables in this procedure are 'declared' implicitly as
'variants.  This includes the timer variables (Timer returns a single)
'and the loop counter, which is typically a Long.

Private Sub cmdVntTypes_Click()

    'assign the base
    x = 2
    
    'assign the exponent
    y = 4

    'start the timer; should be single
    starttime = Timer
                            
    For counter = 1 To cNumIts
    
        'compute x^y
        result = x ^ y
    
    Next counter

    'stop the timer
    stoptime = Timer
    
    'display the result
    Print
    Print "Using Implicit Variant Declarations,"
    Print "Computed x^y "; cNumIts; " times in"
    Print stoptime - starttime; " seconds."
    Print "Result = "; result
    Print


End Sub
