VERSION 5.00
Begin VB.Form frmData03 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Data03 - Immediate vs Memory Loop Bound Demo"
   ClientHeight    =   4395
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5295
   Icon            =   "Data03.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4395
   ScaleWidth      =   5295
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command1 
      Caption         =   "Clear Text"
      Height          =   1095
      Left            =   3840
      TabIndex        =   2
      Top             =   3000
      Width           =   1335
   End
   Begin VB.CommandButton cmdLoopImmed 
      Caption         =   "Compute Loop Using Immediate Data as Loop Bounds"
      Height          =   1095
      Left            =   3840
      TabIndex        =   1
      Top             =   1560
      Width           =   1335
   End
   Begin VB.CommandButton cmdLoopMem 
      Caption         =   "Compute Loop Using Memory References as Loop Bounds"
      Height          =   1095
      Left            =   3840
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "frmData03"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the difference in execution when
'using 'dynamic' loop boundaries and steps (variables) vs. using
'immediate data.
'
'If the code will need variable sized loops (or steps), variables make
'sense. However, if the loop can be coded as fixed, a slight
'performance improvement results when using immediate data rather
'than forcing a memory reference.

Option Explicit

'global declarations
'constants
Const cStart As Long = 1            'immediate loop start
Const cStop As Long = 20            'immediate loop stop
Const cStepSize As Long = 1         'immediate loop step
Const cNumIts As Long = 10000000    'number of iterations

'longs
Dim StartCounter As Long            'memory loop start
Dim StopCounter As Long             'memory loop stop
Dim StepSize As Long                'memory loop step size
Dim Counter As Long                 'test loop counter

'singles
Dim starttimer As Single            'system milliseconds at start of loop
Dim stoptimer As Single             'system milliseconds at loop exit

'uses 'immediate' data reference, rather than memory
Private Sub cmdLoopImmed_Click()

    'local declarations
    'doubles
    Dim itcounter As Long

    'start the timer
    starttimer = Timer
    
    For itcounter = 1 To cNumIts
    
        'do a loop with immediate references
        For Counter = cStart To cStop Step cStepSize
        
        Next Counter
    
    Next itcounter
    
    'stop the timer
    stoptimer = Timer
    
    'display the results
    Print "Inner Loop "; cStart; " to "; cStop; " using Immediate References"
    Print cNumIts; " times in "; stoptimer - starttimer; " seconds."
    Print

End Sub

'Test loop using variable (memory) references for loop boundaries
Private Sub cmdLoopMem_Click()

    'local declarations
    'longs
    Dim itcounter As Long
    
    'assign values for the loop start and stop
    StartCounter = cStart
    StopCounter = cStop
    StepSize = cStepSize
    
    'start the timer
    starttimer = Timer
    
    For itcounter = 1 To cNumIts
    
        'do a loop with memory references for loop bounds
        For Counter = StartCounter To StopCounter Step StepSize
        
        Next Counter
    
    Next itcounter

    'stop the timer
    stoptimer = Timer
    
    'display the results
    Print "Inner Loop "; cStart; " to "; cStop; " using Memory References"
    Print cNumIts; " times in "; stoptimer - starttimer; " seconds."
    Print

End Sub

'clear the print area
Private Sub Command1_Click()

    Cls

End Sub
