VERSION 5.00
Begin VB.Form frmData04 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Data04 - Floating Point vs. Integer Division Operator"
   ClientHeight    =   3015
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5070
   Icon            =   "Data04.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3015
   ScaleWidth      =   5070
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command4 
      Caption         =   "Clear Text"
      Height          =   495
      Left            =   3480
      TabIndex        =   3
      Top             =   2280
      Width           =   1455
   End
   Begin VB.CommandButton Command3 
      Caption         =   "value=100/3"
      Height          =   495
      Left            =   3480
      TabIndex        =   2
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Command2 
      Caption         =   "value=100\3"
      Height          =   495
      Left            =   3480
      TabIndex        =   1
      Top             =   1560
      Width           =   1455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "value=int(100/3)"
      Height          =   495
      Left            =   3480
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "frmData04"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program compares the floating point division operator
' / on integer data to using the integer division operator
' \ when dividing integer data (in both cases, and integer
' result is assumed).

Option Explicit

'global declarations
'constants
Const cNumIts As Long = 100000000       'number of iterations

'singles
Dim timestart As Single
Dim timestop As Single

'computes 100/3 with explict 'type conversion.'
Private Sub Command1_Click()
    
    'local declarations
    'longs
    Dim count As Long           'iteration counter
    Dim lResult As Long         'long result
    
    'start the timer
    timestart = Timer
    
    For count = 1 To cNumIts
    
        'compute float division with float operands, convert to integer
        'after computation
        lResult = Int(100! / 3!)
        
    Next count

    'stop the timer
    timestop = Timer
    
    'display the results
    Print "Using Floating Point Division Operator,"
    Print "Computed int(float/float) "; cNumIts; " times in"
    Print timestop - timestart; " seconds."
    Print "Result = "; lResult
    Print

End Sub

'computes 100/3 assuming integer operands with integer division
'operator
Private Sub Command2_Click()
    
    'local declarations
    'longs
    Dim count As Long           'number of iterations
    Dim lResult As Long         'long result
    
    'start the timer
    timestart = Timer
    
    For count = 1 To cNumIts
    
        'compute integer division with long operands
        lResult = 100& \ 3&
        
    Next count

    'stop the timer
    timestop = Timer
    
    'display the results
    Print "Using Integer Division Operator,"
    Print "Computed long/long "; cNumIts; " times in"
    Print timestop - timestart; " seconds."
    Print "Result = "; lResult
    Print

End Sub

'computes 100/3 using floating point operator
Private Sub Command3_Click()

    'local declarations
    'longs
    Dim count As Long           'iteration counter
    Dim lResult As Long         'long result
    
    'start the timer
    timestart = Timer
    
    For count = 1 To cNumIts
        
        'using floating point operator, and long
        'operands
        lResult = 100& / 3&
        
    Next count

    'stop the timer
    timestop = Timer
    
    'display the results
    Print "Using Floating Point Division Operator,"
    Print "Computed long/long "; cNumIts; " times in"
    Print timestop - timestart; " seconds."
    Print "Result = "; lResult
    Print

End Sub

'clear the print area
Private Sub Command4_Click()

    Cls

End Sub
