VERSION 5.00
Begin VB.Form frmData08 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Data08 - Late vs. Early Object Binding"
   ClientHeight    =   3120
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5070
   Icon            =   "Data08.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3120
   ScaleWidth      =   5070
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Text"
      Height          =   735
      Left            =   3360
      TabIndex        =   2
      Top             =   2160
      Width           =   1575
   End
   Begin VB.CommandButton cmdEarly 
      Caption         =   "Object References using EARLY binding"
      Height          =   735
      Left            =   3360
      TabIndex        =   1
      Top             =   1200
      Width           =   1575
   End
   Begin VB.CommandButton cmdLate 
      Caption         =   "Object References using LATE binding"
      Height          =   735
      Left            =   3360
      TabIndex        =   0
      Top             =   240
      Width           =   1575
   End
End
Attribute VB_Name = "frmData08"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the performance difference between
'early binding and late binding to objects.  Both object variables
'are declared with module scope.
'
'Late binding has the object variable declared as OBJECT type.
'Early binding has the object variable declared as as specific
'class.
'
'Both objects (early and late) are referenced to the CNumLib1
'class.  This demo class contains only a single
'function (method), the LJ_Energy(distance as single) function.
'
'The CNumLib1 class module is the same as the one in Function06
'used to build the NumLib1.dll for the dynamic library call
'demo.

Option Explicit

'global declarations
'constants
Const cNumIts As Long = 1000000         'number of iterations

'singles
Dim starttimer As Single                'system 'ticks' at start of loop
Dim stoptimer As Single                 'system 'ticks' at loop exit

'objects
Dim GenericCompute As Object            'Generic Object
Dim Compute As CNumLib1                 'NumLib1 Class
'clears the print area
Private Sub cmdClear_Click()

    Cls

End Sub

Private Sub cmdEarly_Click()

    'local declarations
    'longs
    Dim Counter As Long         'iteration counter
    
    'singles
    Dim Energy As Single
    
    'start the timer
    starttimer = Timer
    
    'instantiate the compute object as NumLib1 class
    Set Compute = New CNumLib1
    
    For Counter = 1 To cNumIts
    
        'calls the LJ_Energy function
        'in the compute object
        Energy = Compute.LJ_Energy(1.234)       '1.234 is just a value to pass
    
    Next Counter
    
    'stop the timer
    stoptimer = Timer
    
    'display the results
    Print
    Print "Computed pair energy "; cNumIts; " times using"
    Print "early binding to class function call."
    Print "Energy = "; Energy; " in "; stoptimer - starttimer; " seconds."


End Sub

Private Sub cmdLate_Click()

    'local declarations
    'longs
    Dim Counter As Long         'iteration counter
    
    'singles
    Dim Energy As Single
    
    'start the timer
    starttimer = Timer
    
    'instantiate the compute object as NumLib1 class
    Set GenericCompute = New CNumLib1
    
    For Counter = 1 To cNumIts
    
        'calls the LJ_Energy function
        'in the compute object
        Energy = GenericCompute.LJ_Energy(1.234)       '1.234 is just a value to pass
    
    Next Counter
    
    'stop the timer
    stoptimer = Timer
    
    'display the results
    Print
    Print "Computed pair energy "; cNumIts; " times using"
    Print "late binding to class function call."
    Print "Energy = "; Energy; " in "; stoptimer - starttimer; " seconds."


End Sub
