VERSION 5.00
Begin VB.Form frmFunction04 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Function04 - Demo using passing array reference"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4935
   Icon            =   "Function04.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4935
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3360
      TabIndex        =   2
      Top             =   2040
      Width           =   1455
   End
   Begin VB.CommandButton cmdArray 
      Caption         =   "Pass Single Array Reference"
      Height          =   615
      Left            =   3360
      TabIndex        =   1
      Top             =   1200
      Width           =   1455
   End
   Begin VB.CommandButton cmd6Param 
      Caption         =   "Pass Six Parameters"
      Height          =   615
      Left            =   3360
      TabIndex        =   0
      Top             =   360
      Width           =   1455
   End
End
Attribute VB_Name = "frmFunction04"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This function compares passing the individual members
'of an array vs. passing a single reference to the array.
'No work is done in the functions, since the passing is
'being explored.

Option Explicit

'global declarations
'constants
Const cNumIts = 100000000       'number of iterations

'singles
Dim StartTimer As Single        'ticks at start of loop
Dim StopTimer As Single         'ticks at loop exit

'passing the six parameters explicitly
Private Sub cmd6Param_Click()

    'local declarations
    'longs
    Dim ItCounter As Long       'iteration counter
    
    'doubles
    Dim dummy As Double         'return value for function call
    Dim X(6) As Double          'array to be sent
    
    'initialize with some values
    X(1) = 1.234
    X(2) = 2.765
    X(3) = 3.718
    X(4) = 9.234
    X(5) = 0.003
    X(6) = -5.443
    
    'start the timer
    StartTimer = Timer
    
    For ItCounter = 1 To cNumIts
    
        'pass the six values, each by reference
        dummy = Pass6(X(1), X(2), X(3), X(4), X(5), X(6))
    
    Next ItCounter

    'stop the timer
    StopTimer = Timer
    
    'display the results
    Print "Called Function "; cNumIts; " times"
    Print "passing 6 parameters in "
    Print StopTimer - StartTimer; " seconds."
    Print

End Sub

'passes a single reference to the array to the function
Private Sub cmdArray_Click()

    'local declarations
    'longs
    Dim ItCounter As Long       'iteration counter
    
    'doubles
    Dim dummy As Double         'return value for function
    Dim X(6) As Double          'array to pass
    
    'initialize with some values
    X(1) = 1.234
    X(2) = 2.765
    X(3) = 3.718
    X(4) = 9.234
    X(5) = 0.003
    X(6) = -5.443
    
    'start the timer
    StartTimer = Timer
    
    For ItCounter = 1 To cNumIts
    
        'pass only address of array
        dummy = PassRef(X)
    
    Next ItCounter

    'stop the timer
    StopTimer = Timer
    
    'display the results
    Print "Called Function "; cNumIts; " times"
    Print "passing single reference in "
    Print StopTimer - StartTimer; " seconds."
    Print


End Sub

'dummy function that receives 6 doubles and returns a double
Private Function Pass6(ByRef a As Double, ByRef b As Double, _
        ByRef c As Double, ByRef d As Double, ByRef e As Double, _
        ByRef f As Double) As Double
          
    'return a value
    Pass6 = 10.456
        
End Function

'dummy function that receives a single address of the array
'(a long integer!) and returns a double.
Private Function PassRef(ByRef a() As Double) As Double

    'return a value
    PassRef = 10.456

End Function

'clears the display array
Private Sub cmdClear_Click()

    Cls

End Sub
