VERSION 5.00
Begin VB.Form frmRisc02 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "RISC02 - 2d Distance Calculation by CISC and RISC algorithms"
   ClientHeight    =   4230
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6660
   Icon            =   "frmRisc02.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4230
   ScaleWidth      =   6660
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClearText 
      Caption         =   "Clear Text"
      Height          =   735
      Left            =   4680
      TabIndex        =   2
      Top             =   2640
      Width           =   1695
   End
   Begin VB.CommandButton cmdRasCISC 
      Caption         =   "Compute r as CISC"
      Height          =   855
      Left            =   4680
      TabIndex        =   1
      Top             =   480
      Width           =   1695
   End
   Begin VB.CommandButton cmdRasRISC 
      Caption         =   "Compute r as RISC"
      Height          =   855
      Left            =   4680
      TabIndex        =   0
      Top             =   1560
      Width           =   1695
   End
End
Attribute VB_Name = "frmRisc02"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the RISC style for the two dimensional
'distance calculation.

Option Explicit

'Global Declarations
'Constants
Const cNumIts As Long = 10000000
Const x1 As Double = 1.234      'just some values for test coordinates
Const x2 As Double = 2.675
Const y1 As Double = 0.045
Const y2 As Double = 2.073

'Singles
Dim starttimer As Single    'system ticks at start of loop
Dim stoptimer As Single     'system ticks at end of loop

'Doubles


'Clears the output for multiples tests

Private Sub cmdClearText_Click()

    Cls

End Sub

'This procedure computes the 2-d distance in a CISC style, which
'fits the definition of general Scientist Style programming given
'in Chapter 1.

Private Sub cmdRasCISC_Click()

    'Local Declarations
    'Longs
    Dim counter As Long         'Iteration counter

    'Doubles
    Dim r As Double             'computed distance

    starttimer = Timer          'start the timer
    
    For counter = 1 To cNumIts
    
        r = Sqr((x1 - x2) ^ 2 + (y1 - y2) ^ 2)  'compute distance
        
    Next counter
    
    stoptimer = Timer           'stop the timer
    
    'display the results
    Print
    Print "Computed r "; cNumIts; " times by CISC in"
    Print stoptimer - starttimer; " seconds."
    Print "r = "; r

End Sub

'This procedure computes the 2d distance using a RISC style
'algorithm.

Private Sub cmdRasRISC_Click()

    Dim counter As Long         'Iteration counter

    Dim TempX As Double         'holder for (x2-x1)^2
    Dim TempY As Double         'holder for (y2-y1)^2
    Dim r As Double         'computed distance
    
    starttimer = Timer      'start the timer
    
    For counter = 1 To cNumIts
        
        'compute r without the ^ operator
        TempX = x1 - x2
        TempX = TempX * TempX
        TempY = y1 - y2
        TempY = TempY * TempY
        TempY = TempY + TempX
    
        r = Sqr(TempY)
    
    Next counter
    
    stoptimer = Timer       'stop the timer
    
    'Display the results
    Print
    Print "Computed r "; cNumIts; " times by RISC in"
    Print stoptimer - starttimer; " seconds"
    Print "r = "; r
    
End Sub
