VERSION 5.00
Begin VB.Form frmRISC04 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "RISC04 - CISC vs RISC for exp() function"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "frmRISC04.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command3 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3120
      TabIndex        =   2
      Top             =   2040
      Width           =   1455
   End
   Begin VB.CommandButton cmdExpRISC 
      Caption         =   "Compute exp(arg) by RISC Style"
      Height          =   615
      Left            =   3120
      TabIndex        =   1
      Top             =   1200
      Width           =   1455
   End
   Begin VB.CommandButton cmdExpCISC 
      Caption         =   "Compute exp(arg) by CISC style"
      Height          =   615
      Left            =   3120
      TabIndex        =   0
      Top             =   360
      Width           =   1455
   End
End
Attribute VB_Name = "frmRISC04"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates that the exp() function is already
'optimized, so does not benefit from breaking the calculation into
'RISC style steps.

Option Explicit
'Global Declarations
'Constants
Const cNumIts As Long = 10000000        'number of iterations
Const Temp As Double = 89.45        'just a temperature to use
Const kBoltz As Double = 1.381E-23  'Boltzmann's constant
Const Energy As Double = 4.52E-20   'just an energy

'Singles
Dim starttimer As Single        'system ticks at start of loop
Dim stoptimer As Single         'system ticks at loop end

'CISC, or "Scientist Style" calculation using exp() function

Private Sub cmdExpCISC_Click()

    'Local Declarations
    'Longs
    Dim Counter As Long         'iteration counter
    
    'Doubles
    Dim BoltzFactor As Double   'computed Boltzmann Factor
    
    'display a BUSY message
    Print "Computing exp() as CISC ..."
    
    starttimer = Timer          'start the timer
        
    For Counter = 1 To cNumIts
    
        'compute the Boltzmann Factor in CISC Style
        BoltzFactor = Exp(-Energy / (kBoltz * Temp))
    
    Next Counter
    
    stoptimer = Timer           'stop the timer
    
    'Display the results
    Print
    Print "Computed exp(-E/kT) "; cNumIts; " times"
    Print "by CISC style algorithm in "
    Print stoptimer - starttimer; " seconds."
    
End Sub

'This procedure computes the Boltzmann factor in a RISC
'style, following the examples of RISC01 and RISC02

Private Sub cmdExpRISC_Click()

    Dim Counter As Long         'iteration counter
    
    Dim TempArg As Double       'holder for the argument to send the exp
                                'function
    Dim BoltzFactor As Double   'computed Boltzmann factor
    
    'display a BUSY message
    Print "Computing exp() as RISC ..."
    
    starttimer = Timer          'start the timer
    
    For Counter = 1 To cNumIts
        
        'RISC style Boltzmann factor;
        'simplify the function arguement by precomputing
        'to a holder variable
        TempArg = -Energy / (kBoltz * Temp)
        BoltzFactor = Exp(TempArg)
    
    Next Counter
    
    stoptimer = Timer       'stop the timer
    
    'display the result
    Print
    Print "Computed exp(-E/kT) "; cNumIts; " times"
    Print "by RISC style algorithm in "
    Print stoptimer - starttimer; " seconds."
    

End Sub

Private Sub Command3_Click()

    Cls

End Sub
