VERSION 5.00
Begin VB.Form frmOther01 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Single Node 2-D Laplace Eqn Solver"
   ClientHeight    =   6825
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8355
   Icon            =   "Other01.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   455
   ScaleMode       =   0  'User
   ScaleWidth      =   557
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox Text3 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   7200
      TabIndex        =   10
      Text            =   "-30"
      Top             =   1800
      Width           =   855
   End
   Begin VB.TextBox Text2 
      Alignment       =   1  'Right Justify
      Height          =   405
      Left            =   7200
      TabIndex        =   8
      Text            =   "-10"
      Top             =   1320
      Width           =   855
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   7200
      TabIndex        =   5
      Text            =   "10"
      Top             =   840
      Width           =   855
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Abort"
      Height          =   495
      Left            =   6840
      TabIndex        =   3
      Top             =   4440
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.CommandButton cmdCalcLaplace 
      Caption         =   "Solve Laplace Eqn"
      Height          =   615
      Left            =   6720
      TabIndex        =   1
      Top             =   2400
      Width           =   1455
   End
   Begin VB.PictureBox Picture1 
      Height          =   6000
      Left            =   600
      ScaleHeight     =   396
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   396
      TabIndex        =   0
      Top             =   360
      Width           =   6000
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      BackColor       =   &H00C0C0C0&
      Caption         =   "Tolerance = 0.001"
      Height          =   255
      Left            =   6720
      TabIndex        =   11
      Top             =   3240
      Width           =   1575
   End
   Begin VB.Label Label6 
      BackColor       =   &H0000FF00&
      Height          =   255
      Left            =   6720
      TabIndex        =   9
      Top             =   1800
      Width           =   255
   End
   Begin VB.Label Label5 
      BackColor       =   &H00FF0000&
      Height          =   255
      Left            =   6720
      TabIndex        =   7
      Top             =   1320
      Width           =   255
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      BackColor       =   &H00C0C0C0&
      Caption         =   "Voltage Elements"
      Height          =   255
      Left            =   6720
      TabIndex        =   6
      Top             =   480
      Width           =   1455
   End
   Begin VB.Label Label2 
      BackColor       =   &H00000000&
      Height          =   255
      Left            =   6720
      TabIndex        =   4
      Top             =   840
      Width           =   255
   End
   Begin VB.Label Label1 
      BackColor       =   &H00C0C0C0&
      Height          =   615
      Left            =   6840
      TabIndex        =   2
      Top             =   3600
      Width           =   1335
   End
End
Attribute VB_Name = "frmOther01"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'           Other01
'
' This program performs the Point-Gauss-Seidel
' iteration solution to LaPlace's equation.  The
' the specific context is to solve for the
' electric potential in the region of an einzel
' electro-optic lens.
'
' The code uses the cylindrical symmetry of the problem.
' That is, the 3-d problem is reduced to 2-d by noting
' that the solution is a function only of distance from
' the cylinder axis and distance along the axis.  This
' results in a planar (x,y) mesh.
'
' The graphical display region shows the full cylinder
' diameter, simply for visual convenience.  However, it
' should be noted that only half (ie, one radius) is
' actually solved.  When drawn on screen, the solution
' is reflected about the radius.
'
' The user may enter values for the three voltage
' elements being modeled.  The code uses a 'brute
' force' method in that the full Point-Gauss-Seidel
' solution is computed each time the "Solve" button
' is clicked.

Option Explicit

'global declarations
Const OptTol = 0.001        'convergence tolerance
Dim ItCounter As Long       'iteration counter
Dim AbortFlag As Boolean    'flag to help aborting the calc

'event handler to begin calculation
Private Sub cmdCalcLaplace_Click()

    'local declarations
    'longs
    Dim XCounter As Long        'x position
    Dim YCounter As Long        'y position
    
    'singles
    Dim MaxDiff As Single       'max diff between iterations
    Dim LastSoln(500, 500) As Single 'last iteration solution array
    
    'disable gui elements during calculation
    Text1.Enabled = False
    Text2.Enabled = False
    Text3.Enabled = False
    cmdCalcLaplace.Enabled = False
    
    'show abort button
    Command1.Visible = True
    
    'initialize abort flag
    AbortFlag = False
    
    'display a message
    Label1.Caption = "Computing ..."
    
    'let Windows catch up
    DoEvents
    
    'initialize voltage elements to values entered
    'by user
    Boundary_Values
    
    'initialize iteration counter and MaxDiff
    ItCounter = 1
    MaxDiff = OptTol
    
    Do While (MaxDiff >= OptTol) And (ItCounter < 20000)
    
        'initialize maximum difference for
        'this iteration
        MaxDiff = 0
    
        'do for computationally important part of the
        'spatial domain, which is the top left 200x200
        'square
        For XCounter = 1 To 199
    
            For YCounter = 1 To 200
            
                'do only if a 'real' point, not if BC or
                'voltage element
                If Soln(XCounter, YCounter).Status = 0 Then
                            
                    'store old solution to test for convergence
                    LastSoln(XCounter, YCounter) = Soln(XCounter, YCounter).Soln
                            
                    'solve for current point
                    Soln(XCounter, YCounter).Soln = Soln(XCounter - 1, YCounter).Soln + Soln(XCounter, YCounter - 1).Soln + _
                        Soln(XCounter + 1, YCounter).Soln + Soln(XCounter, YCounter + 1).Soln

                    Soln(XCounter, YCounter).Soln = Soln(XCounter, YCounter).Soln * 0.25

                    'get maximum difference to test for convergence
                    If Abs(Soln(XCounter, YCounter).Soln - LastSoln(XCounter, YCounter)) > MaxDiff Then
                    
                        MaxDiff = Abs(Soln(XCounter, YCounter).Soln - LastSoln(XCounter, YCounter))
                        
                    End If

                End If
        
            Next YCounter
    
        Next XCounter
    
        'assign solution along domain boundaries
        For XCounter = 1 To 200
    
            Soln(XCounter, 201).Soln = Soln(XCounter, 199).Soln
        
        Next XCounter
                
        'update iteration message every so often
        If ItCounter Mod 100 = 0 Then
     
            Label1.Caption = "Iteration: " & Str(ItCounter)
            Label1.Caption = Label1.Caption & Chr(13) & "MaxDiff= " & Str(MaxDiff)
            
            'let windows catch up
            DoEvents
    
        End If
    
        'update display every so often
        If ItCounter Mod 1000 = 0 Then
        
            'Paint_Final_Soln
            Paint_Final_Soln
        
        End If

        'increment iteration counter
        ItCounter = ItCounter + 1
    
    Loop
    
    'display a message
    If ItCounter >= 20000 Then
    
        If AbortFlag = True Then
        
            Label1.Caption = "Calculation Aborted"
        
        Else
        
            Label1.Caption = "System did not converge; iterations exceeded 20,000"
    
        End If
    
    Else
    
        Label1.Caption = "System converged after " & Str(ItCounter) & " iterations"
    
    End If
    
    'draw the final solution
    Paint_Final_Soln
    
    'enable gui elements after calculation
    Text1.Enabled = True
    Text2.Enabled = True
    Text3.Enabled = True
    cmdCalcLaplace.Enabled = True

    'hide abort button when not computing
    Command1.Visible = False
    
    'hide tolerance label
    Label4.Visible = False

End Sub

'event to abort calculation
Private Sub Command1_Click()

    ItCounter = 100000
    AbortFlag = True

End Sub

' Entry function; basic initializations
Private Sub Form_Load()

    'set brush for drawing area
    Picture1.FillStyle = vbSolid

    'show the main form, before drawing
    frmOther01.Show
    
    'let Windows catch up
    DoEvents

    'set up problem geometry
    Initialize_Boundary
    
    'assign initial voltages
    Boundary_Values

End Sub

'function to set up the problem geometry, for
'this demo, a simple einzel lens stack.
Private Sub Initialize_Boundary()

    'local declarations
    'longs
    Dim dummy As Long       'return value to API calls
    Dim hDCon As Long       'handle to picture control
    
    'need the handle to picture control for API call
    hDCon = Picture1.hDC
    
    'set the brush colors for voltage element 1
    Picture1.ForeColor = vbBlack
    Picture1.FillColor = vbBlack
    
    'draw voltage element 1, in black
    dummy = Rectangle(hDCon, 0, 0, 5, 400)
    
    'set the brush colors for voltage elements 2
    Picture1.ForeColor = vbBlue
    Picture1.FillColor = vbBlue
    
    'draw voltage elements 2, in blue
    'entry lens, above and below radius
    dummy = Rectangle(hDCon, 70, 0, 75, 180)
    dummy = Rectangle(hDCon, 70, 220, 75, 400)
    
    'exit lens, above and below radius
    dummy = Rectangle(hDCon, 135, 0, 140, 180)
    dummy = Rectangle(hDCon, 135, 220, 140, 400)
    
    'set the brush colors for voltage element 3
    Picture1.ForeColor = vbGreen
    Picture1.FillColor = vbGreen
    
    'draw voltage element 3, in green
    dummy = Rectangle(hDCon, 95, 0, 115, 180)
    dummy = Rectangle(hDCon, 95, 220, 115, 400)
    
    'let windows catch up before exit
    DoEvents

End Sub

'function to paint the actual solution array and the
'solution reflected about the radius.
Private Sub Paint_Final_Soln()

    'local declarations
    'longs
    Dim CurRed As Long          'point color, for contours
    Dim XCounter As Long        'x position
    Dim YCounter As Long        'y position
    
    'singles
    Dim maxsoln As Single       'maximum value in solution array
    Dim minsoln As Single       'minimum value in solution array
    Dim maxsoln_255 As Single     '255/max solution value
    
    'initialize the max and min solution values
    maxsoln = 0
    minsoln = 0
    
    'find max and min solution in actual domain
    For XCounter = 1 To 200
    
        For YCounter = 1 To 200
        
        
            If Soln(XCounter, YCounter).Soln > maxsoln Then
            
                maxsoln = Soln(XCounter, YCounter).Soln
                
            End If
            
            If Soln(XCounter, YCounter).Soln < minsoln Then
            
                minsoln = Soln(XCounter, YCounter).Soln
                
            End If
                        
        Next YCounter
        
    Next XCounter
    
    'normalize to use 256 colors
    maxsoln_255 = 255 / (maxsoln - minsoln)
    
    'do for each point in actual domain
    For XCounter = 1 To 200
    
        For YCounter = 1 To 200
            
            'don't do for points in elements
            If Soln(XCounter, YCounter).Status <> 1 And _
                Soln(XCounter, YCounter).Status <> 2 And _
                Soln(XCounter, YCounter).Status <> 3 Then
                        
                'assign color for solution at point, 0-255
                CurRed = (Soln(XCounter, YCounter).Soln - minsoln) * maxsoln_255
                    
                
                If Soln(XCounter, YCounter).Soln < maxsoln_255 \ 3 Then
                           
                    'plot the point
                    Picture1.PSet (XCounter, YCounter), RGB(CurRed, 0, 0)
                
                    'plot the point's reflection about radius
                    Picture1.PSet (XCounter, 400 - YCounter), RGB(CurRed, 0, 0)
                
                ElseIf Soln(XCounter, YCounter).Soln > 2 * maxsoln_255 \ 3 Then
                
                    'plot the point
                    Picture1.PSet (XCounter, YCounter), RGB(0, 0, CurRed)
                
                    'plot the point's reflection about radius
                    Picture1.PSet (XCounter, 400 - YCounter), RGB(0, 0, CurRed)
                
                Else
                
                    'plot the point
                    Picture1.PSet (XCounter, YCounter), RGB(0, CurRed, 0)
                
                    'plot the point's reflection about radius
                    Picture1.PSet (XCounter, 400 - YCounter), RGB(0, CurRed, 0)
                
                End If
            
            End If
            
        Next YCounter
        
    Next XCounter
    
    
End Sub

'function to assign values to the voltage
'elements
Private Sub Boundary_Values()

    'local declarations
    'longs
    Dim XIndex As Long
    Dim YIndex As Long
    
    'singles
    Dim XCounter As Single
    Dim YCounter As Single
    
    'assign voltages to the elements
    For XCounter = 0 To 200
    
        XIndex = CLng(XCounter)
    
        For YCounter = 0 To 200
        
            YIndex = CLng(YCounter)
        
            Select Case Picture1.Point(XCounter, YCounter)
            
            Case vbBlack
            
                Soln(XIndex, YIndex).Soln = Val(Text1.Text)
                Soln(XIndex, YIndex).Status = 1
                
            Case vbBlue
            
                Soln(XIndex, YIndex).Soln = Val(Text2.Text)
                Soln(XIndex, YIndex).Status = 1
                
            Case vbGreen
            
                Soln(XIndex, YIndex).Soln = 3 * Val(Text3.Text)
                Soln(XIndex, YIndex).Status = 1
                
            End Select
            
        Next YCounter
        
    Next XCounter


End Sub

