#!/bin/bash
#
# Build all demos into current directory
# Requires input of cpu type for march switch on gcc command lines.
# This can be overridden by editing the compile scripts in each chapter
# directory

#clear the terminal display
clear

#save the current directory makeall.sh was called from
MAKEDIR=$PWD

#display prompt for cpu type
echo Please enter a valid cpu type recognized by gcc.  The following is a
echo sample list for x86 cpus.  If you are unsure of specific types accepted 
echo by gcc, choose the one that closest matches the cpu in your system.
echo " "
echo These only effect the scheduling of microoperations within the cpu.
echo " "
echo pentium, pentium2, pentium3, k5, k6, athlon
echo " "
echo " "

#get user input
echo Enter gcc recognized cpu type:
read ARCH

#step through all directories under the current directory
for CHAP in $MAKEDIR/*
do

	#do work only if directory, ie not files like makeall.sh!
	if test -d $CHAP

	  then
	    
	    echo Compiling $CHAP Demos
	    
	    #change to working directory
	    cd $CHAP
	    
	    #run the compile script in each directory
	    #passing the architecture as parameter
	    ./compile $ARCH

	fi

done

#end back where we started
cd $MAKEDIR


