// Data05.c : implementation file
//
// This program compares memory reference times to global data vs.
//	local data.
//
// fnA() uses local data
// fnB() uses global data

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//defines
#define NumIts		50000000	// number of iterations

//global data
//integers
int gCounter;				//global interation counter

//doubles
double gAngle;				//global angle
double gResult;				//global sin(x) result

//functions
void fnA();			
void fnB();			

// compute using LOCAL scope
void fnA()
{

	//general local declarations
	//integers
	int lcounter;				//iteration counter	

	//doubles
	double lAngle;				//local angle
	double lResult;				//local sin(x) result

	//variables for time execution time
	//doubles
	double ElapsedTime;			//ticks during loop
	double t1;					//ticks at start of loop
	double t2;					//ticks at loop end
	
	//display entry message
	printf("\nCompute sin(x) with locally declared data...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(lcounter=1; lcounter <=NumIts; ++lcounter){
        
		//assign the angle
		lAngle = (double)0.785398163; //(double)rand()/RAND_MAX;

		//compute sin(angle)
		lResult = sin(lAngle);
    
    }
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnA()

//compute sin(x) using global data
void fnB()
{

	//general local declarations

	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//display entry message
	printf("\nCompute sin(x) with global data...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(gCounter=1; gCounter <=NumIts; ++gCounter){
        
		//assign the angle
		gAngle = (double)0.785398163; //(double)rand()/RAND_MAX

		//compute sin(angle)
		gResult = sin(gAngle);
    
    }
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnB()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tCompute with local data\n");
		printf("2\tCompute with global data\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//call the user selected function
		switch	(inchar){

			case '1': fnA();
				break;
	
			case '2': fnB();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

}
