// Function01.c : implementation file
//

// This program compares the performance of calling a function with
// using inline code.  The functions are empty and do no work.
//
// The function call routine is in fnA().
// The inline routine is in fnB().


#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//defines
#define NumIts 10000000		//number of iterations

//functions
void fnA();			
void fnB();			

double calc_ljenergy(double R);		// the called function

//perform iterative function calling
void fnA()
{

	//general local declarations
	//integers
	int counter;			  // iteration counter

	//doubles
	double r;                 //distance, a double to pass to function
    double energy;            //energy, holder for function return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end

	//just a value to use
	r = 0;
	
	//display entry message
	printf("\nCalling Function with parameters ...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    
		// call the function, passing a double and
        // returning a double
        energy = calc_ljenergy(r);   

    }
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnA()

// interative inline "function"
void fnB()
{

	//general local declarations
	//integers
	int counter;			//iteration counter

	//doubles
	double r;                 //distance, a double to pass to function
	double r1;				  //holder variable, would be used in energy calc
	double r2;				  //holder variable, would be used in energy calc
    double energy;            //energy, holder for function return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//just values to use
	r = 0;
	energy = 0;
	r1 = 0;
	r2 = 0;
	
	//display entry message
	printf("\nIterative Inline Code...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    

        //no work is actually done
		//no parameters or return values passed

    }
	
	//stop the timer
	t2 = GetTickCount();
	
	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnB()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tIterative Function Calling with 1 Parameter\n");
		printf("2\tIterative Inline Code\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//call the user selected function
		switch	(inchar){

			case '1': fnA();
				break;
	
			case '2': fnB();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

} // End Main

double calc_ljenergy (double R)
{

	double R1;		//these would be used internally in the 
	double R2;		//optimized lj energy computation

	R1 = 0;
	R2 = 0;

	return(0);

}
