// Function03.c : implementation file
//
// This program demonstrates execution time vs. number of parameters
// passed to a function. Simple, dummy functions are used that
// receive two, four and eight double parameters, and each returns
// a double.
//
// This illustrates the parameter dependence of pushing and popping
// data from the program stack space.
//
// The function call with two parameters is in fnA().
// The function call with four parameters is in fnB().
// The function call with eight parameters is in fnC().


#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//defines
#define NumIts 100000000		//number of iterations

//functions
void fnA();			
void fnB();
void fnC();			

double TwoParam (double P1, double P2);
double FourParam (double P1, double P2, double P3, double P4);
double EightParam (double P1, double P2, double P3, double P4,
				   double P5, double P6, double P7, double P8);


// calls a function with two doubles passed, one double is returned
void fnA()
{

	//general local declarations
	//integers
	int counter;			  // iteration counter

	//doubles
	double dummy;             //return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//display entry message
	printf("\nCalling Function with two parameters ...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    
		//call the function, passing two doubles
        //returning a double
        dummy = TwoParam((double)0, (double)0);    

    }
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");

}//end fnA()

// calls a function with four doubles passed, one double is returned 
void fnB()
{
	//general local declarations
	//integers
	int counter;			  // iteration counter

	//doubles
	double dummy;             //return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
		
	//display entry message
	printf("\nCalling Function with four parameters ...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    
		//call the function, passing four doubles
        //returning a double
        dummy = FourParam(0, 0, 0, 0);    

    }
	
	//stop the timer
	t2 = GetTickCount();
	
	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");

}  // End fnB()

// calls a function with eight doubles passed, one double is returned
void fnC()
{

	//general local declarations
	//integers
	int counter;			  // iteration counter

	//doubles
	double dummy;             //return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
		
	//display entry message
	printf("\nCalling Function with eight parameters ...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    
		//call the function, passing eight doubles
		//returning a double
        dummy = EightParam(0, 0, 0, 0, 0, 0, 0, 0);    

    }
	
	//stop the timer
	t2 = GetTickCount();
	
	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnC()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tCall Function with two parameters\n");
		printf("2\tCall Function with four parameters\n");
		printf("3\tCall Function with eight parameters\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//call the user selected function
		switch	(inchar){

			case '1': fnA();
				break;
	
			case '2': fnB();
				break;

			case '3': fnC();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

} // End Main

//two parameter function
double TwoParam(double P1, double P2)
{

	return(0);

}

//four parameter function
double FourParam(double P1, double P2, double P3, double P4)
{

	return(0);

}

//eight parameter function
double EightParam(double P1, double P2, double P3, double P4,
				  double P5, double P6, double P7, double P8)
{

	return(0);

}
