// Function04.c : implementation file
//
// This program compares passing individual data to passing
// an array reference.  No work is done in the functions.
//
// The function call passing six parameters by value is in fnA().
// The function call passing a single array reference is in fnB().


#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//defines
#define NumIts 100000000		//number of iterations

//functions
void fnA();			
void fnB();			

//functions
double Pass6 (double a, double b, double c, double d, double e, 
			  double f);

double PassRef (double *h);


//calls a function passing six double precision parameters
void fnA()
{

	//general local declarations
	//integers
	int counter;			  // iteration counter

	//doubles
	double x[6];			  //array to be sent
    double dummy;			  //return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//initialize with some values to pass
	x[0] = 1.234;
	x[1] = 2.765;
	x[2] = 3.718;
	x[3] = 9.234;
	x[4] = 0.003;
	x[5] = -5.443;
	
	//display entry message
	printf("\nCalling Function with six parameters ...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    

        //pass the six values
		dummy = Pass6(x[0], x[1], x[2], x[3], x[4], x[5]);

    }
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");

}//end fnA()

//passes a single int array reference to a function
void fnB()
{
	//general local declarations
	//integers
	int counter;			  // iteration counter

	//doubles
	double x[6];			  //array to be sent
    double dummy;			  //return value
	
	//variables for time execution time
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//initialize with some values to pass
	x[0] = 1.234;
	x[1] = 2.765;
	x[2] = 3.718;
	x[3] = 9.234;
	x[4] = 0.003;
	x[5] = -5.443;
	
	//display entry message
	printf("\nCalling Function with single array reference ...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(counter=1; counter <= NumIts; ++counter){
    

        //pass the single reference
		dummy = PassRef(x);

    }
	
	//stop the timer
	t2 = GetTickCount();
	
	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");

}  // End fnB()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tCall Function  passing 6 parameters explicitly by value\n");
		printf("2\tCall Function passing  6 parameters by array reference\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//call the user selected function
		switch	(inchar){

			case '1': fnA();
				break;
	
			case '2': fnB();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

} // End Main

//the function that receives six double parameters
double Pass6 (double a, double b, double c, double d, double e, 
			  double f)

{

	return(0);

}

//the function that receives a single array reference
double PassRef (double *h)
{

	return(0);

}
