
//RISC02 compares the CISC style 2 dimensional distance calculation to the RISC
//style.


#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//defines
#define NumIts 10000000		//number of iterations

//functions
void fnCISC();			//CISC style distance
void fnRISC();			//RISC style distance

//computes distance in 'CISC' style
void fnCISC()
{

	//local declarations
	//integers
	int i;			//iteration counter
	
	//doubles
	double x1 = 1.234;	//some values to use for coordinates
	double x2 = 2.675;		
	double y1 = 0.045;
	double y2 = 2.073;
	double r;		//distance between particles
	
	//values needed for timing functions
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
		
	//display entry message
	printf("\nComputing CISC Style Distance...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(i=1; i<= NumIts; ++i){
	
		//compute the distance
		r = sqrt(pow(x1-x2,2) + pow(y1-y2,2));

	}
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	printf("%s%g%s", "Distance = ", r, " \n\n");
	
}//end fnCISC()

void fnRISC()
{

	//local declarations
	//integers
	int i;			//iteration counter
		
	//doubles
	double x1 = 1.234;	//some values to use for coordinates
	double x2 = 2.675;		
	double y1 = 0.045;
	double y2 = 2.073;
	double tempx;		//deltax, then deltax^2
	double tempy;		//deltay, then deltay^2
	double r;		//distance between particles
	
	//values for timing functions
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//initialize r to just a value to use
	r = (double)1.234;
	
	//display entry message
	printf("\nComputing RISC Style Distances...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(i=1; i<= NumIts; ++i){
	
		//compute deltax and deltay
		tempx = x1 - x2;
		tempy = y1 - y2;
		
		//compute deltax^2 and deltay^2
		tempx *= tempx;
		tempy *= tempy;
		
		//compute distance
		r=sqrt(tempx + tempy);
		
	}
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	printf("%s%g%s", "Distance = ", r, " \n\n");
	
}//end fnRISC()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\t2-D Distances in CISC Style\n");
		printf("2\t2-D Distances in RISC Style\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//inchar = getchar();

		//call the user selected function
		switch	(inchar){

			case '1': fnCISC();
				break;
	
			case '2': fnRISC();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

}
