// Multi01.c : implementation file
//

// This program compares a single thread 'application'
// to a two-thread version.
//
// Two thread version worker thread function is in fnA().
// Two thread version main thread is in fnB().
// Single thread version is in fnC(). 

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>

//defines
#define loopend		700000000
#define sleeptime   25			//milliseconds to sleep during loop

//functions
DWORD WINAPI fnA(LPVOID data);			
void fnB();
void fnC();			

//Worker Thread
DWORD WINAPI fnA(LPVOID data)
{

	//general local declarations
	//integers
	int counter;			  // iteration counter
	
	//display entry message
	printf("\nEntering Worker Thread ...\n");
	
	for(counter=1; counter <= loopend; ++counter);

	printf("\nDone with Worker Thread\n");
	
	return(0);

}//end fnA()

// Main Thread of two Thread Version
void fnB()
{

	//general local declarations
	//integers
	int counter;			//iteration counter
	
	//others
	HANDLE thread_handle;	//handle to created thread
	DWORD  thread_id;		//thread id; returned from CreateThread()

	//variables for time execution time
	//doubles
	double starttime;	//ticks at start of process
	double stoptime;	//ticks at end of process
	double ElapsedTime;	//ticks during process
	
	//get start time
	starttime = GetTickCount();
	
	//create the worker thread with API call
	//this thread uses the function Loop_Thread
	thread_handle = CreateThread(NULL,
					0,
					fnA,
					(LPVOID)0,
					0,
					&thread_id);
	
	printf("Starting User Interface Work in Main Thread\n");
	
	for(counter=1; counter <= 100; ++counter){
    
		printf("0");

		//brief pause to simulate work
		Sleep(sleeptime);
        
    	}
	
	//main thread should wait for child to die naturally before
	//releasing handle to OS
	WaitForSingleObject(thread_handle, INFINITE);
	
	//release handle to OS
	CloseHandle(thread_handle);

	//stop the timer
	stoptime = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnB()

// Function Single Thread Version
void fnC()
{

	//general local declarations
	//integers
	int counter;			//iteration counter
	
	//variables for time execution time
	//doubles
	double starttime;	//ticks at start of process
	double stoptime;	//ticks at end of process
	double ElapsedTime;	//ticks during process
	
	//display entry message
	printf("\nSingle Thread Function...\n");
	
	//get start time
	starttime = GetTickCount();
	
	printf("Starting Worker Function\n");
	
	for(counter=1; counter <= loopend; ++counter); 
	
	printf("Starting User Interface Function\n");
	
	for(counter=1; counter <= 100; ++counter){
    
		printf("0");
		Sleep(sleeptime);
        
    }
	
	
	//stop the timer
	stoptime = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n");
	
}//end fnC()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tSingle Threaded Application\n");
		printf("2\tMultiThreaded Application\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//call the user selected function
		switch	(inchar){

			case '1': fnC();
				break;
	
			case '2': fnB();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

} // End Main


