// Data05Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Data05.h"
#include "Data05Dlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//global declarations
const int cNumIts = 50000000;	//number of iterations

//integers
int gCounter;				//global interation counter

//doubles
double gAngle;				//global angle
double gResult;				//global sin(x) result

/////////////////////////////////////////////////////////////////////////////
// CData05Dlg dialog

CData05Dlg::CData05Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CData05Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CData05Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CData05Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CData05Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CData05Dlg, CDialog)
	//{{AFX_MSG_MAP(CData05Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CData05Dlg message handlers

BOOL CData05Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CData05Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CData05Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// compute using LOCAL scope
void CData05Dlg::OnButton1() 
{
	//local declarations
	//integers
	int lcounter;				//local iteration counter
	int j;						//output string pointer

	//doubles
	double lAngle;				//local angle
	double lResult;				//local sin(x) result
	double starttime;			//ticks at start of loop
	double stoptime;			//ticks at loop exit
	double ElapsedTime;			//ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

	for(lcounter=1; lcounter <=cNumIts; ++lcounter){
        
		//assign the angle
		lAngle = (double)rand()/RAND_MAX; //0.785398163;

		//compute sin(angle)
		lResult = sin(lAngle);
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Computed sin(x) with Local Data ", cNumIts, " times in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");
	j += sprintf(buffer + j, "%s%g", "Result = ", lResult);

	MessageBox(buffer,
					 "Computed with Local Data",
					 MB_OK | MB_ICONEXCLAMATION);
	
}

//compute sin(x) using global data
void CData05Dlg::OnButton2() 
{
	//local declarations
	//integers
	int j;						//output string pointer

	//doubles
	double starttime;			//ticks at start of loop
	double stoptime;			//ticks at loop exit
	double ElapsedTime;			//ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

	for(gCounter=1; gCounter <=cNumIts; ++gCounter){
        
		//assign the angle
		gAngle = (double)rand()/RAND_MAX; //0.785398163;

		//compute sin(angle)
		gResult = sin(gAngle);
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Computed sin(x) with Global Data ", cNumIts, " times in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");
	j += sprintf(buffer + j, "%s%g", "Result = ", gResult);

	MessageBox(buffer,
					 "Computed with Global Data",
					 MB_OK | MB_ICONEXCLAMATION);	
}
