// Function03Dlg.cpp : implementation file
//
// This program demonstrates execution time vs. number of parameters
// passed to a function. Simple, dummy functions are used that
// receive two, four and eight double parameters, and each returns
// a double.
//
// This illustrates the parameter dependence of pushing and popping
// data from the program stack space.

#include "stdafx.h"
#include "Function03.h"
#include "Function03Dlg.h"
#include "math.h"
#include "stdio.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
static int cNumIts = 100000000;

//functions

double TwoParam (double P1, double P2);
double FourParam (double P1, double P2, double P3, double P4);
double EightParam (double P1, double P2, double P3, double P4,
				   double P5, double P6, double P7, double P8);

/////////////////////////////////////////////////////////////////////////////
// CFunction03Dlg dialog

CFunction03Dlg::CFunction03Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction03Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction03Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction03Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction03Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction03Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction03Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction03Dlg message handlers

BOOL CFunction03Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction03Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction03Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// calls a function with two doubles passed, one double is returned
void CFunction03Dlg::OnButton1() 
{
	
	//Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double dummy;             //return value
    
	//characters
	char buffer[200];		//output string

    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        dummy = TwoParam((double)0, (double)0);    //call the function, passing two doubles
                                     //returning a double

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly passed two parameters 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	

}


// calls a function with four doubles passed, one double is returned
void CFunction03Dlg::OnButton2() 
{
	
	//Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double dummy;             //return value

	//characters
	char buffer[200];		//output string

    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        dummy = FourParam(0, 0, 0, 0);    //call the function, passing four doubles
											  //returning a double

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly passed four parameters 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	

}


//calls a function with eight doubles passed, one double returned
void CFunction03Dlg::OnButton3() 
{

	//Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double dummy;             //return value
    
	//characters
	char buffer[200];		//output string

	//start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		//call the function, passing eight doubles
		//returning a double
        dummy = EightParam(0, 0, 0, 0, 0, 0, 0, 0);

    }
    
	//stop the timer
    stoptime = GetTickCount();      
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly passed eight parameters 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	

}

//two parameter function
double TwoParam(double P1, double P2)
{

	return(0);

}

//four parameter function
double FourParam(double P1, double P2, double P3, double P4)
{

	return(0);

}

//eight parameter function
double EightParam(double P1, double P2, double P3, double P4,
				  double P5, double P6, double P7, double P8)
{

	return(0);

}
