// Function08Dlg.cpp : implementation file
//
// This program compares the use of recursive function calls to 
// solving a recursive problem iteratively.  The factorial of 100
// is computed in this demo.

#include "stdafx.h"
#include "Function08.h"
#include "Function08Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//globals
const int cNumIts = 1000000;		//number of iterations

//functions
double Recurs_Fact(int Arg1);

/////////////////////////////////////////////////////////////////////////////
// CFunction08Dlg dialog

CFunction08Dlg::CFunction08Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction08Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction08Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction08Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction08Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction08Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction08Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction08Dlg message handlers

BOOL CFunction08Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction08Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction08Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//compute 100! in recursive function call
void CFunction08Dlg::OnButton1() 
{
	//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//buffer position pointer

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double Result;			  //return value
    
	//characters
	char buffer[200];		//output string

	//start the timer
	starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    

        //call the recursive function
		Result = Recurs_Fact(100);

    }
    
	//stop the timer
    stoptime = GetTickCount();      
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Recursively computed 100! 1,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");
	j += sprintf(buffer + j, "%s%g", "100! = ", Result);

	MessageBox(buffer, "Recursive 100! Calculation",
				MB_OK | MB_ICONEXCLAMATION);
	
	
}

//iterative computation of 100!
void CFunction08Dlg::OnButton2() 
{
	//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//buffer position pointer
	int fact;				//factorial 'counter'

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double Result;			  //return value
    
	//characters
	char buffer[200];		//output string

	//start the timer
	starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		//initialize Result
		Result = 1;

        //compute factorial iteratively
		for(fact = 1; fact<=100; fact++){

			Result *= fact;

		}

    }
    
	//stop the timer
    stoptime = GetTickCount();      
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Iteratively computed 100! 1,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");
	j += sprintf(buffer + j, "%s%g", "100! = ", Result);

	MessageBox(buffer, "Iterative 100! Calculation",
				MB_OK | MB_ICONEXCLAMATION);
		
}

//function to compute factorial recursively
double Recurs_Fact(int Arg1)
{

	double answer;

	if(Arg1==1) return(1);
	answer = Recurs_Fact(Arg1 -1) * Arg1;

	return(answer);

}
