// Loop01Dlg.cpp : implementation file
//
// This program demonstrates loop unrolling for a simple function 
// assignment.
//
// The rolled routine is in CLoop01Dlg::OnButton1().
// The unrolled routine is in CLoop01Dlg::OnButton2().

#include "stdafx.h"
#include "Loop01.h"
#include "Loop01Dlg.h"
#include "math.h"
#include "stdio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
int cNumIts = 10000000;

/////////////////////////////////////////////////////////////////////////////
// CLoop01Dlg dialog

CLoop01Dlg::CLoop01Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoop01Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoop01Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLoop01Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoop01Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLoop01Dlg, CDialog)
	//{{AFX_MSG_MAP(CLoop01Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoop01Dlg message handlers

BOOL CLoop01Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLoop01Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLoop01Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Assign the function using a rolled loop
void CLoop01Dlg::OnButton1() 
{

	//local declarations
	//integers
	int counter;			//iteration counter
	int fncounter;			//function assignment counter
	int j;					//buffer 'pointer'

	//doubles
	double expvalu;			//arguement factor
	double starttime;		//system ticks at start of loop
	double stoptime;		//system ticks at loop exit
	double ElapsedTime;		//system ticks during loop
	double r[11];				//assigned function value

	//characters
	char buffer[200];		//output string

	//just a value to use
	expvalu = 3.13;      
    
	//start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		
		for(fncounter=1; fncounter <= 10; ++fncounter){


			//assign the function array using the counter
			//as the independent variable
			r[fncounter] = exp(-fncounter * expvalu);
            
        }
        
    }
    
	//stop the timer
    stoptime = GetTickCount();		
    
	//compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Using Unrolled Loop, assigned r=exp(-x) 10,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Rolled Function Assignment",
				MB_OK | MB_ICONEXCLAMATION);
	
	

}

// simple function assignment using an unrolled loop
void CLoop01Dlg::OnButton2() 
{

	//local declarations
	//integers
	int counter;			//iteration counter
	int j;					//buffer 'pointer'

	//doubles
	double expvalu;			//arguement factor
	double starttime;		//system ticks at start of loop
	double stoptime;		//system ticks at loop exit
	double ElapsedTime;		//system ticks during loop
	double r[11];				//assigned function value

	//character strings
	char buffer[200];		//output string

	//just a value to use
	expvalu = 3.13;      
    
	//start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    

			//assign the function array using explicit code
			r[1] = exp(-1 * expvalu);
            r[2] = exp(-2 * expvalu);
			r[3] = exp(-3 * expvalu);
			r[4] = exp(-4 * expvalu);
			r[5] = exp(-5 * expvalu);
			r[6] = exp(-6 * expvalu);
			r[7] = exp(-7 * expvalu);
			r[8] = exp(-8 * expvalu);
			r[9] = exp(-9 * expvalu);
			r[10] = exp(-10 * expvalu);
        
        
    }
    
	//stop the timer
    stoptime = GetTickCount();		
    
	//compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Using Unrolled Loop, assigned r=exp(-x) 10,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Rolled Function Assignment",
				MB_OK | MB_ICONEXCLAMATION);
	
	
	

}
