// Loop02Dlg.cpp : implementation file
//
// This program demonstrates loop unrolling for a simple vector dot
// product.
//
// The rolled routine is CLoop02Dlg::OnButton1().
// The unrolled routine is CLoop02Dlg::OnButton2().

#include "stdafx.h"
#include "Loop02.h"
#include "Loop02Dlg.h"
#include "math.h"
#include "stdio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
static int cNumIts = 100000000;		//number of iterations

/////////////////////////////////////////////////////////////////////////////
// CLoop02Dlg dialog

CLoop02Dlg::CLoop02Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoop02Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoop02Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CLoop02Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoop02Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLoop02Dlg, CDialog)
	//{{AFX_MSG_MAP(CLoop02Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoop02Dlg message handlers

BOOL CLoop02Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLoop02Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLoop02Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//computes dot product between two vectors in rolled up code
void CLoop02Dlg::OnButton1() 
{

	//local declarations
	//integers
	int counter;			//iteration counter
	int dotcounter;			//dot product counter
	int j;					//buffer 'pointer'

	//singles
	float a[3];				//vector a
	float b[3];				//vector b
	float c;				//dot product result

	//doubles
	double starttime;		//system ticks at start of loop
	double stoptime;		//system ticks at loop exit
	double ElapsedTime;		//system ticks during loop

	//characters
	char buffer[200];		//output string

	//initialize the two vectors with some made up values
	a[1] = (float)23.45;
	a[2] = (float)14.65;
	a[3] = (float)33.87;

	b[1] = (float)36.99;
	b[2] = (float)21.32;
	b[3] = (float)17.38;

	//start the timer
	starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		c = (float)0;
		
		//dot product in rolled loop
		for(dotcounter=1; dotcounter <= 3; ++dotcounter){

			c += a[dotcounter] * b[dotcounter];
        
		}
    }
    
	//stop the timer
    stoptime = GetTickCount();		
    
	//compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Using Rolled Loop, performed dot product 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Rolled Dot Product",
				MB_OK | MB_ICONEXCLAMATION);
	
	
	

	
}


//computes the dot product in unrolled loop
void CLoop02Dlg::OnButton2() 
{

	//local declarations
	//integers
	int counter;			//iteration counter
	int j;					//buffer 'pointer'

	//singles
	float a[3];				//vector a
	float b[3];				//vector b
	float c;				//dot product result

	//doubles
	double starttime;		//system ticks at start of loop
	double stoptime;		//system ticks at loop exit
	double ElapsedTime;		//system ticks during loop

	//characters
	char buffer[200];		//output string

	//initialize the two vectors with some made up values
	a[1] = (float)23.45;
	a[2] = (float)14.65;
	a[3] = (float)33.87;

	b[1] = (float)36.99;
	b[2] = (float)21.32;
	b[3] = (float)17.38;

	//start the timer
	starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){

		//note also eliminated a c=0 line!!
		
		//dot product in unrolled loop
		c = a[1] * b[1] + a[2] * b[2] + a[3] * b[3];


    }
    
	//stop the timer
    stoptime = GetTickCount();		
    
	//compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Using Unrolled Loop, performed dot product 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Unrolled Dot Product",
				MB_OK | MB_ICONEXCLAMATION);
	
	

}
