; Listing generated by Microsoft (R) Optimizing Compiler Version 12.00.9044.0 

	TITLE	C:\Program Files\Microsoft Visual Studio\MyProjects\ProgBook\Math Libraries\GenMath\genSolvers.c
	.386P
include listing.inc
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS	ENDS
$$SYMBOLS	SEGMENT BYTE USE32 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES	SEGMENT BYTE USE32 'DEBTYP'
$$TYPES	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
;	COMDAT _genGaussSeidel
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _genRungeKutta
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif

INCLUDELIB LIBCD
INCLUDELIB OLDNAMES

PUBLIC	_genGaussSeidel
PUBLIC	__real@bf800000
EXTRN	_free:NEAR
EXTRN	_malloc:NEAR
EXTRN	_fabs:NEAR
EXTRN	__chkesp:NEAR
EXTRN	__fltused:NEAR
;	COMDAT __real@bf800000
; File C:\Program Files\Microsoft Visual Studio\MyProjects\ProgBook\Math Libraries\GenMath\genSolvers.c
CONST	SEGMENT
__real@bf800000 DD 0bf800000r			; -1
; Function compile flags: /Odt /GZ /ZI
CONST	ENDS
;	COMDAT _genGaussSeidel
_TEXT	SEGMENT
_a$ = 8
_t$ = 12
_b$ = 16
_n$ = 20
_OptTol$ = 24
_j$ = -4
_k$ = -8
_indx$ = -12
_NumIts$ = -16
_delta_T$ = -20
_max_delta_T$ = -24
_sum1$ = -28
_sum2$ = -32
_Tdiff$ = -36
_t_old$ = -40
_ajj_inv$ = -44
_genGaussSeidel PROC NEAR				; COMDAT

; 66   : {

	push	ebp
	mov	ebp, esp
	sub	esp, 112				; 00000070H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-112]
	mov	ecx, 28					; 0000001cH
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 67   : 	//local declarations
; 68   : 	//integers
; 69   : 	int j;					//row counter in Gauss-Seidel solver
; 70   : 	int k;					//column counter in Gauss-Seidel solver
; 71   : 	int *indx;				//pointer math offset for matrix row
; 72   : 	int NumIts;				//number of iterations in Gauss-Seidel solver
; 73   : 							//this is used to prevent infinite loop in case
; 74   : 							//of poor or non-convergence in the solver
; 75   : 
; 76   : 	//floats
; 77   : 	float delta_T;			//max change in Temperature; used to test for convergence
; 78   : 	float max_delta_T;		//used to determine the delta_T
; 79   : 	float sum1;				//a temporary summation holder
; 80   : 	float sum2;				//a temporary summation holder
; 81   : 	float Tdiff;			//individual Temperature difference; used
; 82   : 							//to compute max_delta_T
; 83   : 	float *t_old;			//pointer to temporary 'last' iteration
; 84   : 	float *ajj_inv;			//pointer to -1/a[j][j]
; 85   : 
; 86   : 
; 87   : 	//allocate for t_old
; 88   : 	t_old = malloc(n * 4);

	mov	eax, DWORD PTR _n$[ebp]
	shl	eax, 2
	push	eax
	call	_malloc
	add	esp, 4
	mov	DWORD PTR _t_old$[ebp], eax

; 89   : 
; 90   : 	//allocate for -1/a[j][j]
; 91   : 	ajj_inv = malloc(n * 4);

	mov	eax, DWORD PTR _n$[ebp]
	shl	eax, 2
	push	eax
	call	_malloc
	add	esp, 4
	mov	DWORD PTR _ajj_inv$[ebp], eax

; 92   : 
; 93   : 	//allocate for indx[j]
; 94   : 	indx = malloc(n * 4);

	mov	eax, DWORD PTR _n$[ebp]
	shl	eax, 2
	push	eax
	call	_malloc
	add	esp, 4
	mov	DWORD PTR _indx$[ebp], eax

; 95   : 
; 96   : 	//solve the system for t(j) using Gauss-Seidel procedure
; 97   : 
; 98   : 	//initialize values need for determining convergence
; 99   : 	NumIts = 1;

	mov	DWORD PTR _NumIts$[ebp], 1

; 100  : 	delta_T = 1;

	mov	DWORD PTR _delta_T$[ebp], 1065353216	; 3f800000H

; 101  : 	max_delta_T = 0;

	mov	DWORD PTR _max_delta_T$[ebp], 0

; 102  : 
; 103  : 	
; 104  : 	
; 105  : 	for(j=0; j < n; ++j){

	mov	DWORD PTR _j$[ebp], 0
	jmp	SHORT $L929
$L930:
	mov	eax, DWORD PTR _j$[ebp]
	add	eax, 1
	mov	DWORD PTR _j$[ebp], eax
$L929:
	mov	eax, DWORD PTR _j$[ebp]
	cmp	eax, DWORD PTR _n$[ebp]
	jge	SHORT $L931

; 106  : 
; 107  : 		//save guess values of t(j)'s into current t(j)'s
; 108  : 		*(t_old + j) = *(t + j);

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _t_old$[ebp]
	mov	edx, DWORD PTR _j$[ebp]
	mov	esi, DWORD PTR _t$[ebp]
	mov	edx, DWORD PTR [esi+edx*4]
	mov	DWORD PTR [ecx+eax*4], edx

; 109  : 
; 110  : 		//calculate row pointer once outside iteration
; 111  : 		*(indx + j) = j * n;

	mov	eax, DWORD PTR _j$[ebp]
	imul	eax, DWORD PTR _n$[ebp]
	mov	ecx, DWORD PTR _j$[ebp]
	mov	edx, DWORD PTR _indx$[ebp]
	mov	DWORD PTR [edx+ecx*4], eax

; 112  : 
; 113  : 		//calculate -1/a[j][j] once outside iteration
; 114  : 		*(ajj_inv + j) = -1 / (*(a + *(indx + j) + j));

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _indx$[ebp]
	mov	edx, DWORD PTR [ecx+eax*4]
	mov	eax, DWORD PTR _a$[ebp]
	lea	ecx, DWORD PTR [eax+edx*4]
	mov	edx, DWORD PTR _j$[ebp]
	fld	DWORD PTR [ecx+edx*4]
	fdivr	DWORD PTR __real@bf800000
	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _ajj_inv$[ebp]
	fstp	DWORD PTR [ecx+eax*4]

; 115  : 
; 116  : 	}

	jmp	SHORT $L930
$L931:
$L932:

; 117  : 
; 118  : 
; 119  : 	do{
; 120  : 
; 121  : 		for(j=0; j < n; ++j){

	mov	DWORD PTR _j$[ebp], 0
	jmp	SHORT $L935
$L936:
	mov	eax, DWORD PTR _j$[ebp]
	add	eax, 1
	mov	DWORD PTR _j$[ebp], eax
$L935:
	mov	eax, DWORD PTR _j$[ebp]
	cmp	eax, DWORD PTR _n$[ebp]
	jge	$L937

; 122  : 			
; 123  : 			//update t(j) part using t(i)'s (i<j) already updated
; 124  : 
; 125  : 			//zero sum1 since running sum
; 126  : 			sum1 = 0;

	mov	DWORD PTR _sum1$[ebp], 0

; 127  : 
; 128  : 			//compute offset for row
; 129  : 			//indx = j * n;
; 130  : 
; 131  : 			for(k=0; k <= j-1; ++k){

	mov	DWORD PTR _k$[ebp], 0
	jmp	SHORT $L938
$L939:
	mov	eax, DWORD PTR _k$[ebp]
	add	eax, 1
	mov	DWORD PTR _k$[ebp], eax
$L938:
	mov	eax, DWORD PTR _j$[ebp]
	sub	eax, 1
	cmp	DWORD PTR _k$[ebp], eax
	jg	SHORT $L940

; 132  : 
; 133  : 				sum1 += *(a + *(indx + j) + k) * *(t + k);

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _indx$[ebp]
	mov	edx, DWORD PTR [ecx+eax*4]
	mov	eax, DWORD PTR _a$[ebp]
	lea	ecx, DWORD PTR [eax+edx*4]
	mov	edx, DWORD PTR _k$[ebp]
	mov	eax, DWORD PTR _k$[ebp]
	mov	esi, DWORD PTR _t$[ebp]
	fld	DWORD PTR [ecx+edx*4]
	fmul	DWORD PTR [esi+eax*4]
	fadd	DWORD PTR _sum1$[ebp]
	fstp	DWORD PTR _sum1$[ebp]

; 134  : 
; 135  : 			}

	jmp	SHORT $L939
$L940:

; 136  : 
; 137  : 			//update t(j) part using t(i)'s (i>j) not yet updated
; 138  : 			//this iteration
; 139  : 
; 140  : 			//zero sum2 since running sum
; 141  : 			sum2 = 0;

	mov	DWORD PTR _sum2$[ebp], 0

; 142  : 
; 143  : 			for(k = j+1; k < n; ++k){

	mov	eax, DWORD PTR _j$[ebp]
	add	eax, 1
	mov	DWORD PTR _k$[ebp], eax
	jmp	SHORT $L941
$L942:
	mov	eax, DWORD PTR _k$[ebp]
	add	eax, 1
	mov	DWORD PTR _k$[ebp], eax
$L941:
	mov	eax, DWORD PTR _k$[ebp]
	cmp	eax, DWORD PTR _n$[ebp]
	jge	SHORT $L943

; 144  : 
; 145  : 				sum2 += *(a + *(indx + j) + k) * *(t_old + k);

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _indx$[ebp]
	mov	edx, DWORD PTR [ecx+eax*4]
	mov	eax, DWORD PTR _a$[ebp]
	lea	ecx, DWORD PTR [eax+edx*4]
	mov	edx, DWORD PTR _k$[ebp]
	mov	eax, DWORD PTR _k$[ebp]
	mov	esi, DWORD PTR _t_old$[ebp]
	fld	DWORD PTR [ecx+edx*4]
	fmul	DWORD PTR [esi+eax*4]
	fadd	DWORD PTR _sum2$[ebp]
	fstp	DWORD PTR _sum2$[ebp]

; 146  : 
; 147  : 			}

	jmp	SHORT $L942
$L943:

; 148  : 
; 149  : 			*(t + j) = sum1 + sum2 - *(b + j);

	fld	DWORD PTR _sum1$[ebp]
	fadd	DWORD PTR _sum2$[ebp]
	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _b$[ebp]
	fsub	DWORD PTR [ecx+eax*4]
	mov	edx, DWORD PTR _j$[ebp]
	mov	eax, DWORD PTR _t$[ebp]
	fstp	DWORD PTR [eax+edx*4]

; 150  : 			*(t + j) *= *(ajj_inv + j);

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _t$[ebp]
	mov	edx, DWORD PTR _j$[ebp]
	mov	esi, DWORD PTR _ajj_inv$[ebp]
	fld	DWORD PTR [ecx+eax*4]
	fmul	DWORD PTR [esi+edx*4]
	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _t$[ebp]
	fstp	DWORD PTR [ecx+eax*4]

; 151  : 
; 152  : 			//find max change for this set of t(j)
; 153  : 			Tdiff = (float)fabs(*(t + j) - *(t_old + j));

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _t$[ebp]
	mov	edx, DWORD PTR _j$[ebp]
	mov	esi, DWORD PTR _t_old$[ebp]
	fld	DWORD PTR [ecx+eax*4]
	fsub	DWORD PTR [esi+edx*4]
	sub	esp, 8
	fstp	QWORD PTR [esp]
	call	_fabs
	add	esp, 8
	fstp	DWORD PTR _Tdiff$[ebp]

; 154  : 
; 155  : 			if(Tdiff > max_delta_T){

	fld	DWORD PTR _Tdiff$[ebp]
	fcomp	DWORD PTR _max_delta_T$[ebp]
	fnstsw	ax
	and	eax, 16640				; 00004100H
	jne	SHORT $L945

; 156  : 
; 157  : 				max_delta_T = Tdiff;

	mov	eax, DWORD PTR _Tdiff$[ebp]
	mov	DWORD PTR _max_delta_T$[ebp], eax
$L945:

; 158  : 
; 159  : 			}
; 160  : 
; 161  : 		}

	jmp	$L936
$L937:

; 162  : 
; 163  : 		//increment number of iterations
; 164  : 		++NumIts;

	mov	eax, DWORD PTR _NumIts$[ebp]
	add	eax, 1
	mov	DWORD PTR _NumIts$[ebp], eax

; 165  : 
; 166  : 		//reset t change values used for convergence testing
; 167  : 		delta_T = max_delta_T;

	mov	eax, DWORD PTR _max_delta_T$[ebp]
	mov	DWORD PTR _delta_T$[ebp], eax

; 168  : 		max_delta_T = 0;

	mov	DWORD PTR _max_delta_T$[ebp], 0

; 169  : 
; 170  : 		//save the old t(j)'s
; 171  : 		for(j = 0; j < n; ++j){

	mov	DWORD PTR _j$[ebp], 0
	jmp	SHORT $L946
$L947:
	mov	eax, DWORD PTR _j$[ebp]
	add	eax, 1
	mov	DWORD PTR _j$[ebp], eax
$L946:
	mov	eax, DWORD PTR _j$[ebp]
	cmp	eax, DWORD PTR _n$[ebp]
	jge	SHORT $L948

; 172  : 
; 173  : 			*(t_old + j) = *(t + j);

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _t_old$[ebp]
	mov	edx, DWORD PTR _j$[ebp]
	mov	esi, DWORD PTR _t$[ebp]
	mov	edx, DWORD PTR [esi+edx*4]
	mov	DWORD PTR [ecx+eax*4], edx

; 174  : 
; 175  : 		}

	jmp	SHORT $L947
$L948:

; 176  : 
; 177  : 	}while ((delta_T >= OptTol) & (NumIts <= 1000));

	fld	DWORD PTR _delta_T$[ebp]
	fcomp	DWORD PTR _OptTol$[ebp]
	fnstsw	ax
	and	eax, 256				; 00000100H
	jne	SHORT $L980
	mov	DWORD PTR -112+[ebp], 1
	jmp	SHORT $L981
$L980:
	mov	DWORD PTR -112+[ebp], 0
$L981:
	xor	eax, eax
	cmp	DWORD PTR _NumIts$[ebp], 1000		; 000003e8H
	setle	al
	mov	ecx, DWORD PTR -112+[ebp]
	and	ecx, eax
	test	ecx, ecx
	jne	$L932

; 178  : 
; 179  : 	//free memory allocated for local arrays
; 180  : 	free(t_old);

	mov	eax, DWORD PTR _t_old$[ebp]
	push	eax
	call	_free
	add	esp, 4

; 181  : 	free(ajj_inv);

	mov	eax, DWORD PTR _ajj_inv$[ebp]
	push	eax
	call	_free
	add	esp, 4

; 182  : 	free(indx);

	mov	eax, DWORD PTR _indx$[ebp]
	push	eax
	call	_free
	add	esp, 4

; 183  : 
; 184  : 	return(NumIts);

	mov	eax, DWORD PTR _NumIts$[ebp]

; 185  : 
; 186  : } //end genGaussSeidel

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 112				; 00000070H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_genGaussSeidel ENDP
_TEXT	ENDS
PUBLIC	_genRungeKutta
PUBLIC	__real@3fe0000000000000
PUBLIC	__real@3fc555555c7dda4b
EXTRN	_errno:DWORD
;	COMDAT __real@3fe0000000000000
CONST	SEGMENT
__real@3fe0000000000000 DQ 03fe0000000000000r	; 0.5
CONST	ENDS
;	COMDAT __real@3fc555555c7dda4b
CONST	SEGMENT
__real@3fc555555c7dda4b DQ 03fc555555c7dda4br	; 0.166667
; Function compile flags: /Odt /GZ /ZI
CONST	ENDS
;	COMDAT _genRungeKutta
_TEXT	SEGMENT
_x$ = 8
_y$ = 16
_fx$ = 20
_h$ = 24
_n$ = 32
_j$ = -4
_k1$ = -12
_k2$ = -20
_k3$ = -28
_k4$ = -36
_fn$ = -44
_h_2$ = -52
_yn$ = -60
_xarg$ = -68
_yarg$ = -76
_genRungeKutta PROC NEAR				; COMDAT

; 228  : {

	push	ebp
	mov	ebp, esp
	sub	esp, 140				; 0000008cH
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-140]
	mov	ecx, 35					; 00000023H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 229  : 
; 230  : 	//local declarations
; 231  : 	//integers
; 232  : 	int	j;					//function value counter
; 233  : 
; 234  : 	//doubles
; 235  : 	double	k1;				//Runge Kutta k1 term
; 236  : 	double	k2;				//Runge Kutta k2 term
; 237  : 	double	k3;				//Runge Kutta k3 term
; 238  : 	double	k4;				//Runge Kutta k4 term
; 239  : 	double	fn;				//return value for call to f(x,y)
; 240  : 	double	h_2;			//h/2
; 241  : 	double	yn;				//'current' y(x)
; 242  : 	double	xarg;			//x value sent to f(x,y)
; 243  : 	double	yarg;			//y value sent to f(x,y)
; 244  : 
; 245  : 	//compute h/2
; 246  : 	h_2 = (0.5 * h);

	fld	QWORD PTR __real@3fe0000000000000
	fmul	QWORD PTR _h$[ebp]
	fstp	QWORD PTR _h_2$[ebp]

; 247  : 
; 248  : 	//solve for each value of x
; 249  : 	for(j=0; j < n; ++j){

	mov	DWORD PTR _j$[ebp], 0
	jmp	SHORT $L972
$L973:
	mov	eax, DWORD PTR _j$[ebp]
	add	eax, 1
	mov	DWORD PTR _j$[ebp], eax
$L972:
	mov	eax, DWORD PTR _j$[ebp]
	cmp	eax, DWORD PTR _n$[ebp]
	jge	$L974

; 250  : 
; 251  : 		//cache 'current' yn
; 252  : 		yn = *(y + j);

	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _y$[ebp]
	mov	edx, DWORD PTR [ecx+eax*8]
	mov	DWORD PTR _yn$[ebp], edx
	mov	eax, DWORD PTR [ecx+eax*8+4]
	mov	DWORD PTR _yn$[ebp+4], eax

; 253  : 
; 254  : 		//get f(x,y) for k1
; 255  : 		fn = fx(x,yn);

	mov	esi, esp
	mov	eax, DWORD PTR _yn$[ebp+4]
	push	eax
	mov	ecx, DWORD PTR _yn$[ebp]
	push	ecx
	mov	edx, DWORD PTR _x$[ebp+4]
	push	edx
	mov	eax, DWORD PTR _x$[ebp]
	push	eax
	call	DWORD PTR _fx$[ebp]
	add	esp, 16					; 00000010H
	cmp	esi, esp
	call	__chkesp
	fstp	QWORD PTR _fn$[ebp]

; 256  : 		k1 = h * fn;

	fld	QWORD PTR _h$[ebp]
	fmul	QWORD PTR _fn$[ebp]
	fstp	QWORD PTR _k1$[ebp]

; 257  : 
; 258  : 		//compute x and y for k2
; 259  : 		xarg = (x + h_2);

	fld	QWORD PTR _x$[ebp]
	fadd	QWORD PTR _h_2$[ebp]
	fstp	QWORD PTR _xarg$[ebp]

; 260  : 		yarg = (yn + (0.5 * k1));

	fld	QWORD PTR __real@3fe0000000000000
	fmul	QWORD PTR _k1$[ebp]
	fadd	QWORD PTR _yn$[ebp]
	fstp	QWORD PTR _yarg$[ebp]

; 261  : 
; 262  : 		//get f(x,y) for k2
; 263  : 		fn = fx(xarg, yarg);

	mov	esi, esp
	mov	eax, DWORD PTR _yarg$[ebp+4]
	push	eax
	mov	ecx, DWORD PTR _yarg$[ebp]
	push	ecx
	mov	edx, DWORD PTR _xarg$[ebp+4]
	push	edx
	mov	eax, DWORD PTR _xarg$[ebp]
	push	eax
	call	DWORD PTR _fx$[ebp]
	add	esp, 16					; 00000010H
	cmp	esi, esp
	call	__chkesp
	fstp	QWORD PTR _fn$[ebp]

; 264  : 		k2 = h * fn;

	fld	QWORD PTR _h$[ebp]
	fmul	QWORD PTR _fn$[ebp]
	fstp	QWORD PTR _k2$[ebp]

; 265  : 
; 266  : 		//compute y for k3; xarg is same as for k2
; 267  : 		yarg = yn + (0.5 * k2);

	fld	QWORD PTR __real@3fe0000000000000
	fmul	QWORD PTR _k2$[ebp]
	fadd	QWORD PTR _yn$[ebp]
	fstp	QWORD PTR _yarg$[ebp]

; 268  : 
; 269  : 		//get f(x,y) for k3
; 270  : 		fn = fx(xarg, yarg);

	mov	esi, esp
	mov	eax, DWORD PTR _yarg$[ebp+4]
	push	eax
	mov	ecx, DWORD PTR _yarg$[ebp]
	push	ecx
	mov	edx, DWORD PTR _xarg$[ebp+4]
	push	edx
	mov	eax, DWORD PTR _xarg$[ebp]
	push	eax
	call	DWORD PTR _fx$[ebp]
	add	esp, 16					; 00000010H
	cmp	esi, esp
	call	__chkesp
	fstp	QWORD PTR _fn$[ebp]

; 271  : 		k3 = h * fn;

	fld	QWORD PTR _h$[ebp]
	fmul	QWORD PTR _fn$[ebp]
	fstp	QWORD PTR _k3$[ebp]

; 272  : 
; 273  : 		//compute x and y for k4
; 274  : 		xarg = x + h;

	fld	QWORD PTR _x$[ebp]
	fadd	QWORD PTR _h$[ebp]
	fstp	QWORD PTR _xarg$[ebp]

; 275  : 		yarg = yn + k3;

	fld	QWORD PTR _yn$[ebp]
	fadd	QWORD PTR _k3$[ebp]
	fstp	QWORD PTR _yarg$[ebp]

; 276  : 
; 277  : 		//get f(x,y) for k4
; 278  : 		fn = fx(xarg, yarg);

	mov	esi, esp
	mov	eax, DWORD PTR _yarg$[ebp+4]
	push	eax
	mov	ecx, DWORD PTR _yarg$[ebp]
	push	ecx
	mov	edx, DWORD PTR _xarg$[ebp+4]
	push	edx
	mov	eax, DWORD PTR _xarg$[ebp]
	push	eax
	call	DWORD PTR _fx$[ebp]
	add	esp, 16					; 00000010H
	cmp	esi, esp
	call	__chkesp
	fstp	QWORD PTR _fn$[ebp]

; 279  : 		k4 = h * fn;

	fld	QWORD PTR _h$[ebp]
	fmul	QWORD PTR _fn$[ebp]
	fstp	QWORD PTR _k4$[ebp]

; 280  : 
; 281  : 		//compute y(n+1) = yn + 1/6 * (k1+ 2k2 + 2k3 + k4)
; 282  : 		k2 *= 2;

	fld	QWORD PTR _k2$[ebp]
	fadd	ST(0), ST(0)
	fstp	QWORD PTR _k2$[ebp]

; 283  : 		k3 *= 2;

	fld	QWORD PTR _k3$[ebp]
	fadd	ST(0), ST(0)
	fstp	QWORD PTR _k3$[ebp]

; 284  : 		k2 += k3;

	fld	QWORD PTR _k2$[ebp]
	fadd	QWORD PTR _k3$[ebp]
	fstp	QWORD PTR _k2$[ebp]

; 285  : 		k1 += k2 + k4;

	fld	QWORD PTR _k2$[ebp]
	fadd	QWORD PTR _k4$[ebp]
	fadd	QWORD PTR _k1$[ebp]
	fstp	QWORD PTR _k1$[ebp]

; 286  : 
; 287  : 		*(y+j+1) = yn + one_sixth * k1;

	fld	QWORD PTR __real@3fc555555c7dda4b
	fmul	QWORD PTR _k1$[ebp]
	fadd	QWORD PTR _yn$[ebp]
	mov	eax, DWORD PTR _j$[ebp]
	mov	ecx, DWORD PTR _y$[ebp]
	fstp	QWORD PTR [ecx+eax*8+8]

; 288  : 
; 289  : 		//increment x by the step size
; 290  : 		x += h;

	fld	QWORD PTR _x$[ebp]
	fadd	QWORD PTR _h$[ebp]
	fstp	QWORD PTR _x$[ebp]

; 291  : 
; 292  : 	}

	jmp	$L973
$L974:

; 293  : 
; 294  : 	return(errno);

	mov	eax, DWORD PTR _errno

; 295  : 
; 296  : } // End genRungeKutta

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 140				; 0000008cH
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_genRungeKutta ENDP
_TEXT	ENDS
END
