/////////////////////////// Vector Header File ///////////////////////
//																    //
//  Defines the functions and type needed for the Vector part       //
//  of the genMath Library.                                         //
//																	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////// Data Types //////////////////////////

//////////////////////////////// FUNCTIONS ///////////////////////////

//dot product of two 2d vectors
int VectorDotProd2d(
					float	*VectorA,
					float	*VectorB,
					float	*DotProd);

//dot product of two 3d vectors
int VectorDotProd3d(
					float	*VectorA,
					float	*VectorB,
					float	*DotProd);

//sum of two 2d vectors
int VectorAdd2d(
				float	*VectorA,
				float	*VectorB,
				float	*Sum);

//sum of two 3d vectors
int VectorAdd3d(
				float	*VectorA,
				float	*VectorB,
				float	*Sum);

//Negate a 2d vector
int VectorNegate2d(
				float	*VectorA,
				float	*VectorB);

//Negate a 3d vector
int VectorNegate3d(
				float	*VectorA,
				float	*VectorB);

//Multiply a 2d vector by a scalar
int	VectorScale2d(
				  float	*VectorA,
				  float	Scale,
				  float	*ScaledVector);

//Multiply a 3d vector by a scalar
int	VectorScale3d(
				  float	*VectorA,
				  float	Scale,
				  float	*ScaledVector);

//length of a 2d vector
int VectorLength2d(
				   float	*Vector,
				   float	*Len);

//length of a 3d vector
int VectorLength3d(
				   float	*Vector,
				   float	*Len);

//angle between two 2d vectors
int VectorAngle2d(
				   float	*VectorA,
				   float	*VectorB,
				   double	*CosAngle);

//angle between two 3d vectors
int VectorAngle3d(
				   float	*VectorA,
				   float	*VectorB,
				   double	*CosAngle);