/////////////////////////// genVector Header File ////////////////////
//																    //
//  Defines the functions and type needed for the genVector part    //
//  of the genMath Library.                                         //
//																	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////// Data Types //////////////////////////

//////////////////////////////// FUNCTIONS ///////////////////////////

// generic vector dot product
int genVectorDotProd(
					 float	*VectorA,
					 float	*VectorB,
					 int	dimen,
					 float	*Result);

// generic length of vector
int genVectorLength(
					float	*Vector,
					int		dimen,
					float	*Length);

//generic vector multiplied by scalar
int genVectorScale(
				   float	*Vector,
				   int		dimen,
				   float	scalar,
				   float	*ScaledVector);

//generic vector addition
int genVectorAdd(
				 float	*VectorA,
				 float	*VectorB,
				 int	dimen,
				 float	*VectorSum);

//angle between two generic vectors
int genVectorAngle(
				   float	*VectorA,
				   float	*VectorB,
				   int		dimen,
				   double	*CosAngle);

//length of cross product of two generic vectors
int genVectorCrossProdLen(
						  float	*VectorA,
						  float	*VectorB,
						  int	dimen,
						  float	*CrossProdLen);

//negative of vector
int genVectorNegate(
				 float	*VectorA,
				 float	*VectorB,
				 int	dimen);

 